#pragma once
#include <ChamberComponent.h>
#include <SpecialCell.h>
#include <memory>
#include <iostream>

template<typename WidthType, typename ColourType>
class Layer : public ChamberComponent, private WidthType {
  using WidthType::getWidth;
public:
  Layer(ChamberComponent* parent) :
    ChamberComponent(parent)
  {
  }

  void fillCells() override
  {
    unsigned width = getWidth();
    for (int ii = m_children.size() * width; ii < getMaxX(); ii += width) {
      m_children.emplace_back(new SpecialCell<WidthType, ColourType>(ii, getMyY(), this));

    }
  }

  /** By definition a layer has hight 1.
   *
   *  Have a look into the visualize function to see the truth of this statement.
   */
  unsigned getMaxY() const override
  {
    return 1;
  }

  /** Overrides to draw some part of the y-axis before drawing all the Cells in one line.
   */
  std::string visualize() override
  {
    std::cout <<  getMyY() << "\t | ";
    for (auto& childPtr : m_children) {
      std::cout << childPtr->visualize();
    }
    std::cout << std::endl;
    return "";
  }

};
